[BITS 32]
%define	PAGE_DIRECTORY	01000h
%define	PAGE_TABLE		02000h

Init_Paging:
	cli
	
	mov esi,PageMsg
	call PrintPMode
	
	xor ecx,ecx
	xor edx,edx
@pg_loop1:
	cmp ecx,1024	; page the first 4Mb of memory
	je @pg_1
	mov eax,edx
	or eax,3		; set supervisor, read/write
	mov dword[PAGE_TABLE+ecx*4],eax

	add edx,4096
	inc ecx
	jmp @pg_loop1

@pg_1:
	mov eax,PAGE_TABLE
	or eax,3
	mov [es:PAGE_DIRECTORY],eax
	
	xor ecx,ecx
@pg_loop2:
	inc ecx
	mov dword[PAGE_DIRECTORY+ecx*4],02h	; 010 binary supervisor, not present
	cmp ecx,1024
	jne @pg_loop2

	xor eax,eax
	mov cr3,eax

	mov eax,PAGE_DIRECTORY
	mov cr3,eax

	mov eax,cr0
	or eax,80000000h
	mov cr0,eax
	
	mov esi,PageOk
	call PrintPMode	
	ret

AllocPage:
	push ebp
	mov ebp,esp

	mov eax,[ebp+08h]

	leave
	ret